码迷,mamicode.com
首页 > 其他好文 > 详细

hdu 1394 Minimum Inversion Number(线段树)

时间:2014-08-13 22:38:27      阅读:332      评论:0      收藏:0      [点我收藏+]

标签:des   style   blog   color   java   使用   os   io   

Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10853    Accepted Submission(s): 6676


Problem Description
The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.
 

Input
The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.
 

Output
For each case, output the minimum inversion number on a single line.
 

Sample Input
10 1 3 6 9 0 8 5 7 4 2
 

Sample Output
16
 


题解及代码:

       线段树的经典题目,用线段树来求数字序列的逆序数,这里我讲解一下程序求逆序数的思想。

       我们使用线段树的叶子节点那顺序记录第k大的数的有无,我们从开始扫描数字序列数组,每进来一个数x,就寻找它的叶子节点并标记为1,然后回溯更新线段区间,然后我们查询x进来之前比x大的数有多少个,使用query(x+1,n,1)就可以了。

      接下来就是说这道题了,我们求出序列的逆序数之后,记录为sum,然后从序列中第一个元素开始扫描,把它放到最后,这样我们会发现,当我们把它拿出来之后,逆序数会减小x-1,因为x后面比x小的数有x-1个,当把它放在最后的时候,逆序数会增加n-x,因为x前面比x大的数有n-x个。


接下来直接写就可以了:


#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <string>
#define maxn 5010
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define ALL %I64d
using namespace std;
typedef long long  ll;


struct segment
{
    int l,r;
    int value;
} son[maxn<<2];

void PushUp(int rt)
{
    son[rt].value=son[rt<<1].value+son[rt<<1|1].value;
}

void Build(int l,int r,int rt)
{
    son[rt].l=l;
    son[rt].r=r;
    son[rt].value=0;
    if(l==r)
    {
        //scanf("%d",&son[rt].value);
        return;
    }
    int m=(l+r)/2;
    Build(lson);
    Build(rson);
    //PushUp(rt);
}

void Update_1(int p,int value,int rt)
{
    if(son[rt].l==son[rt].r)
    {
        son[rt].value=value;
        return;
    }

    int m=(son[rt].l+son[rt].r)/2;
    if(p<=m)
        Update_1(p,value,rt<<1);
    else
        Update_1(p,value,rt<<1|1);

    PushUp(rt);
}


int Query(int l,int r,int rt)
{
    if(son[rt].l==l&&son[rt].r==r)
    {
        return son[rt].value;
    }

    int m=(son[rt].l+son[rt].r)/2;
    int ret=0;

    if(r<=m)
        ret=Query(l,r,rt<<1);
    else if(l>m)
        ret=Query(l,r,rt<<1|1);
    else
    {
        ret=Query(l,m,rt<<1);
        ret+=Query(m+1,r,rt<<1|1);
    }
    return ret;
}

int main()
{
   int n;
   while(scanf("%d",&n)!=EOF)
   {
       Build(1,n,1);

       int x[5010],sum=0,ans;
       for(int i=1;i<=n;i++)
       {
           scanf("%d",&x[i]);
           x[i]+=1;
           sum+=Query(x[i],n,1);
           Update_1(x[i],1,1);
       }
       ans=sum;
       //cout<<ans<<endl;
       for(int i=1;i<=n;i++)
       {
           sum=sum+n+1-2*x[i];
           ans=min(ans,sum);
       }
       printf("%d\n",ans);
   }
    return 0;
}








hdu 1394 Minimum Inversion Number(线段树),布布扣,bubuko.com

hdu 1394 Minimum Inversion Number(线段树)

标签:des   style   blog   color   java   使用   os   io   

原文地址:http://blog.csdn.net/knight_kaka/article/details/38541257

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!